From 14814cd71ca2fac0857c51615dfcb0f6fd13655b Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Bastien=20ROUCARI=C3=88S?= <roucaries.bastien@gmail.com>
Date: Wed, 15 Mar 2017 12:10:07 +0100
Subject: [PATCH 4/7] Factorize owns_file

---
 scripts/dpkg-maintscript-helper.sh | 25 +++++++++++++++++--------
 1 file changed, 17 insertions(+), 8 deletions(-)

diff --git a/scripts/dpkg-maintscript-helper.sh b/scripts/dpkg-maintscript-helper.sh
index b4b3ac1b3..0b867d805 100755
--- a/scripts/dpkg-maintscript-helper.sh
+++ b/scripts/dpkg-maintscript-helper.sh
@@ -412,14 +412,8 @@ prepare_dir_to_symlink()
 
 	# If there are locally created files or files owned by another package
 	# we should not perform the switch.
-	find "$PATHNAME" -print0 | xargs -0 -n1 sh -c '
-		package="$1"
-		file="$2"
-		if ! dpkg-query -L "$package" | grep -F -q -x "$file"; then
-			exit 1
-		fi
-		exit 0
-	' check-files-ownership "$PACKAGE" || \
+	find "$PATHNAME" -print0 | xargs -0 -n1 \
+		dpkg-maintscript-helper package_owns_file_or_error $PACKAGE || \
 		error "directory '$PATHNAME' contains files not owned by" \
 		      "package $PACKAGE, cannot switch to symlink"
 
@@ -515,6 +509,18 @@ ensure_package_owns_file() {
 	return 0
 }
 
+
+package_owns_file_or_error() {
+       local PACKAGE="$1"
+       local FILE="$2"
+       if ! ensure_package_owns_file $PACKAGE $FILE ; then
+	   error "File '$FILE' not owned by package " \
+		 "'$PACKAGE'"
+	   return 1
+       fi
+       return 0
+}
+
 symlink_match()
 {
          local SYMLINK="$1"
@@ -614,6 +620,9 @@ symlink_to_dir)
 dir_to_symlink)
 	dir_to_symlink "$@"
 	;;
+package_owns_file_or_error)
+        package_owns_file_or_error "$@"
+        ;;
 --help|help|-?)
 	usage
 	;;
-- 
2.11.0

